unit UntAnaliseCombinatoria;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls, math;

type
  TfrmAnaliseCombinatoria = class(TForm)
    Label1: TLabel;
    GbOperacoes: TGroupBox;
    btnOrdem2: TSpeedButton;
    btnOrdem3: TSpeedButton;
    btnOrdem4: TSpeedButton;
    btnSair: TSpeedButton;
    pnArranjo: TPanel;
    Label2: TLabel;
    txta1: TEdit;
    txtA2: TEdit;
    Label5: TLabel;
    Label3: TLabel;
    btnSimples: TButton;
    pnResultSimples: TPanel;
    Label4: TLabel;
    Label6: TLabel;
    txtR1: TEdit;
    Label7: TLabel;
    txtR2: TEdit;
    btnOkr: TButton;
    pnRepeticao: TPanel;
    PNCombinacao: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    txtC1: TEdit;
    txtC2: TEdit;
    BtnOkC: TButton;
    pnResultC: TPanel;
    pnPermutacao: TPanel;
    Label12: TLabel;
    Label14: TLabel;
    txtP: TEdit;
    btnPermu: TButton;
    pnresultp: TPanel;
    procedure btnSairClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure btnOrdem2Click(Sender: TObject);
    procedure btnSimplesClick(Sender: TObject);
    procedure btnOkrClick(Sender: TObject);
    procedure btnOrdem3Click(Sender: TObject);
    procedure BtnOkCClick(Sender: TObject);
    procedure btnOrdem4Click(Sender: TObject);
    procedure btnPermuClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAnaliseCombinatoria: TfrmAnaliseCombinatoria;

implementation

{$R *.dfm}

function Fatorial(n: Extended): Extended;
begin
  if n = 0 then
    Fatorial := 1
  else
    Fatorial := n * Fatorial(n - 1);
end;

function Arredondar(Valor: Double; Dec: Integer): Double;
var
  Valor1, Numero1, Numero2, Numero3: Double;
begin
  Valor1 := Exp(Ln(10) * (Dec + 1));
  Numero1 := Int(Valor * Valor1);
  Numero2 := (Numero1 / 10);
  Numero3 := Round(Numero2);
  Result := (Numero3 / (Exp(Ln(10) * Dec)));
end;

procedure TfrmAnaliseCombinatoria.btnSairClick(Sender: TObject);
begin
  frmAnaliseCombinatoria.close;
end;

procedure TfrmAnaliseCombinatoria.FormKeyPress(Sender: TObject;
  var Key: Char);
begin
  //habilita o enter como tab
  if key = #13 then
  begin
    key := #0;
    perform(WM_NEXTDLGCTL, 0, 0);
  end;

  if Key = #27 then
    close;
end;

procedure TfrmAnaliseCombinatoria.btnOrdem2Click(Sender: TObject);
begin
  pnArranjo.Visible := true;
  PNCombinacao.Visible := false;
  pnPermutacao.Visible := false;
  txta1.SetFocus;
end;

procedure TfrmAnaliseCombinatoria.btnSimplesClick(Sender: TObject);
var
  a, b, bb, arranjo: real;
begin
  if (StrToInt(txta1.Text) > StrToInt(txtA2.Text)) or (StrToInt(txta1.Text) = StrToInt(txtA2.Text)) then begin
    a := Fatorial(StrToFloat(txta1.Text));
    bb := StrToFloat(txta1.Text) - StrToFloat(txta2.Text);
    b := Fatorial(bb);

    arranjo := Arredondar((a / b), 6);
    pnResultSimples.Caption := FloatToStr(arranjo);
  end else
    ShowMessage('O valor de A deve ser maior que o valor de b');
  txta1.SetFocus;
end;

procedure TfrmAnaliseCombinatoria.btnOkrClick(Sender: TObject);
var
  arranjo: real;
begin
  arranjo := power(StrToFloat(txtR2.Text), StrToFloat(txtR1.Text));
  pnRepeticao.Caption := FloatToStr(arranjo);
  txtR1.SetFocus;
end;

procedure TfrmAnaliseCombinatoria.btnOrdem3Click(Sender: TObject);
begin
  pnArranjo.Visible := false;
  PNCombinacao.Visible := true;
  pnPermutacao.Visible := false;
  txtC1.SetFocus;
end;

procedure TfrmAnaliseCombinatoria.BtnOkCClick(Sender: TObject);
var
  combina: real;
begin
//C=C(m,p)=m!/[p!(m-p)!], m=10, p=4
  //Condio para que ocorra uma permutao
  if (0 < StrToInt(txtC1.Text)) and (0 <= StrToInt(txtC2.Text)) and (StrToInt(txtC2.Text) <= StrToInt(txtC1.Text)) then begin
    combina := Fatorial(StrToFloat(txtC1.Text)) / (fatorial(StrToFloat(txtC2.Text)) * (Fatorial(StrToFloat(txtC1.Text) - StrToFloat(txtC2.Text))));
    pnResultC.Caption := FloatToStr(combina);
  end else
    ShowMessage('Essa combinao no  possivel');
  txtC1.SetFocus;
end;

procedure TfrmAnaliseCombinatoria.btnOrdem4Click(Sender: TObject);
begin
  pnArranjo.Visible := false;
  PNCombinacao.Visible := false;
  pnPermutacao.Visible := true;
  txtP.SetFocus;
end;

procedure TfrmAnaliseCombinatoria.btnPermuClick(Sender: TObject);
var
  permuta: real;
begin

  permuta := fatorial(StrToFloat(txtP.Text));
  pnresultp.Caption := FloatToStr(permuta);
  txtP.SetFocus;
end;

end.

