unit UntPitagoras;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls;

type
  TfrmPitagoras = class(TForm)
    imgPitagoras: TImage;
    Label1: TLabel;
    txta: TEdit;
    txtb: TEdit;
    txtc: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label7: TLabel;
    GroupBox1: TGroupBox;
    btnCalcular: TButton;
    lblPitagoras: TLabel;
    lblResultado: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure btnCalcularClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPitagoras: TfrmPitagoras;

implementation

uses Math, UntArea, UntBhaskara, untPrincipal;

{$R *.dfm}

function Arredondar(Valor: Double; Dec: Integer): Double;
var
  Valor1, Numero1, Numero2, Numero3: Double;
begin
  Valor1 := Exp(Ln(10) * (Dec + 1));
  Numero1 := Int(Valor * Valor1);
  Numero2 := (Numero1 / 10);
  Numero3 := Round(Numero2);
  Result := (Numero3 / (Exp(Ln(10) * Dec)));
end;


procedure TfrmPitagoras.btnCalcularClick(Sender: TObject);
var
  a, b, c: real;
begin
  if (txta.Text = '') or (txta.Text = '0') then begin
    a := Arredondar(Sqrt(Power(StrToFloat(txtb.Text), 2) + Power(StrToFloat(txtc.Text), 2)), 6);
    lblPitagoras.Caption := 'a =';
    lblResultado.Caption := FloatToStr(a);
  end else begin
    if StrToInt(txta.Text) < StrToInt(txtb.Text) then
      ShowMessage('A valor de A deve ser maior que o valor B')
    else begin
      if (txtb.Text = '') or (txtb.Text = '0') then
      begin
        b := Arredondar(Sqrt(Power(StrToFloat(txta.Text), 2) - Power(StrToFloat(txtc.Text), 2)), 6);
        lblPitagoras.Caption := 'b =';
        lblResultado.Caption := FloatToStr(b);
      end;

      if (txtc.Text = '') or (txtc.Text = '0') then
      begin
        c := Arredondar(Sqrt(Power(StrToFloat(txta.Text), 2) - Power(StrToFloat(txtb.Text), 2)), 6);
        lblPitagoras.Caption := 'c =';
        lblResultado.Caption := FloatToStr(c);
      end;
    end;
  end;
  txta.SetFocus;
end;

procedure TfrmPitagoras.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //habilita o enter como tab
  if key = #13 then
  begin
    key := #0;
    perform(WM_NEXTDLGCTL, 0, 0);
  end;

  if Key = #27 then
    close;

end;

end.

